local trp3rio = CreateFrame("Frame")
trp3rio:RegisterEvent("ADDON_LOADED")
trp3rio:RegisterEvent("PLAYER_LOGIN")
trp3rio:RegisterEvent("PLAYER_LOGOUT")
trp3rio:RegisterEvent("PLAYER_ENTERING_WORLD")


local ignoretooltip = false
local loadedstuff = false

local normalRaidColor = "|cff1eff00"
local normalRaidColorText = "|cff98f989"
local heroicRaidColor = "|cff0070dd"
local heroicRaidColorText = "|cff67abea"
local mythicRaidColor = "|cffa335ee"
local mythicRaidColorText = "|cffce94f7"


local function fixFontsTrp3RIO (dummy)

--Incredibly rough but it works, for now
			local line = _G[strconcat(TRP3_CharacterTooltip:GetName(), "TextLeft", TRP3_CharacterTooltip:NumLines())]
			local font, _ , flag = line:GetFont()
			line:SetFont(font, 12, flag)
			
			local line2 = _G[strconcat(TRP3_CharacterTooltip:GetName(), "TextRight", TRP3_CharacterTooltip:NumLines())]
			local font2, _ , flag2 = line2:GetFont()
			line2:SetFont(font2, 12, flag2)
			
			--print('called')


end


--Debug table from https://stackoverflow.com/questions/9168058/how-to-dump-a-table-to-console
-- Print contents of `tbl`, with indentation.
-- `indent` sets the initial level of indentation.
local function tprint (tbl, indent)
  if not indent then indent = 0 end
  for k, v in pairs(tbl) do
    formatting = string.rep("  ", indent) .. k .. ": "
    if type(v) == "table" then
      print(formatting)
      tprint(v, indent+1)
    elseif type(v) == 'boolean' then
      print(formatting .. tostring(v))      
    else
      print(formatting .. v)
    end
  end
end

trp3rio:SetScript("OnEvent", function(self, event, arg1, arg2)


    if event == "PLAYER_LOGIN" and loadedstuff == false then
		--loadedstuff = true

	 if TRP3_CharacterTooltip ~= nil then
			TRP3_CharacterTooltip:HookScript("OnShow", function(t)

				
				--print(TRP3_CharacterTooltip['target'])
				--print(RaiderIO.HasPlayerProfile(TRP3_CharacterTooltip['target']))
						
				
				if (RaiderIO.HasPlayerProfile(TRP3_CharacterTooltip['target']) == true) then
				
					loadedstuff = false
				
				
					--This player has a Raider.io Profile
					
					thisPlayerName = TRP3_CharacterTooltip['target']

		
					thisPlayerTables = RaiderIO.GetPlayerProfile(0, thisPlayerName)
					
					
					
				if (thisPlayerTables[1] or thisPlayerTables[2]) then
				
					--if (thisPlayerTables[2]['profile']['mainProgress']) then
						--print(thisPlayerName)
						--tprint(thisPlayerTables[2]['profile']['mainProgress'])
					--end

								
					TRP3_CharacterTooltip:AddDoubleLine(" ", " ", 100, 100, 0)
					TRP3_CharacterTooltip:AddDoubleLine("Raider.IO", " ", 100, 100, 0)
					fixFontsTrp3RIO()
					
				
				end
				

				
				for i=1,3 do

						if (thisPlayerTables[i]) then
						
						
				
						
							if (thisPlayerTables[i]['profile']['dataType']) == 1 then
								--M+ data
								
								
								
								
								--This char
								varPlayerScore = 0
								if (thisPlayerTables[i]['profile']['mplusCurrent']['score']) then
									varPlayerScore = thisPlayerTables[i]['profile']['mplusCurrent']['score'];
								end
								varPlayerScoreNum = varPlayerScore
								varPlayerPrevSeason = false
								varPlayerPrevSeasonLabel = ""
								
								if (thisPlayerTables[i]['profile']['mplusPrevious']['score']) then
									if (varPlayerScore <= thisPlayerTables[i]['profile']['mplusPrevious']['score']) then
										varPlayerPrevSeason = true
										varPlayerPrevSeasonLabel = "Current "
									end
								end
								
								if (varPlayerScore and varPlayerScore ~= 0) then
									TRP3_CharacterTooltip:AddDoubleLine(varPlayerPrevSeasonLabel .. "M+ Score", varPlayerScore, 0.8, 0.8, 0.8, RaiderIO.GetScoreColor(varPlayerScoreNum));
									fixFontsTrp3RIO()
								end
								
								
								if (varPlayerPrevSeason) then	
									varPlayerScorePrev = "±" .. thisPlayerTables[i]['profile']['mplusPrevious']['score']
									varPlayerScorePrevNum = thisPlayerTables[i]['profile']['mplusPrevious']['score']
									TRP3_CharacterTooltip:AddDoubleLine("Best M+ Score", varPlayerScorePrev, 0.8, 0.8, 0.8, RaiderIO.GetScoreColor(varPlayerScorePrevNum));
									fixFontsTrp3RIO()
								end
								
								
								
								
								-- Main
								varPlayerMainScore = 0
								if (thisPlayerTables[i]['profile']['mplusMainCurrent']['score']) then
									varPlayerMainScore = thisPlayerTables[i]['profile']['mplusMainCurrent']['score'];
								end
								varPlayerMainScoreNum = varPlayerMainScore
								varPlayerMainPrevSeason = false
								varPlayerMainPrevSeasonLabel = ""
								
								
								if (thisPlayerTables[i]['profile']['mplusMainPrevious']['score']) then
									if (varPlayerMainScore <= thisPlayerTables[i]['profile']['mplusMainPrevious']['score']) then
										varPlayerMainPrevSeason = true
										varPlayerMainPrevSeasonLabel = "Current "
									end
								end
								
								-- Only show if main's score is higher than this char's score
								if (varPlayerMainScore and varPlayerMainScore ~= 0 and varPlayerMainScore > varPlayerScore) then
									TRP3_CharacterTooltip:AddDoubleLine("Main's " .. varPlayerMainPrevSeasonLabel .. "M+ Score", varPlayerMainScore, 0.8, 0.8, 0.8, RaiderIO.GetScoreColor(varPlayerScoreNum));
									fixFontsTrp3RIO()
								end
								
								
								if (varPlayerMainPrevSeason and thisPlayerTables[i]['profile']['mplusMainPrevious']['score'] > varPlayerScore) then	
									varPlayerMainScorePrev = "±" .. thisPlayerTables[i]['profile']['mplusMainPrevious']['score']
									varPlayerMainScorePrevNum = thisPlayerTables[i]['profile']['mplusMainPrevious']['score']
									TRP3_CharacterTooltip:AddDoubleLine("Main's Best M+ Score", varPlayerMainScorePrev, 0.8, 0.8, 0.8, RaiderIO.GetScoreColor(varPlayerMainScorePrevNum));
									fixFontsTrp3RIO()
								end
								

								
								
								
							end
							
							if (thisPlayerTables[i]['profile']['dataType']) == 2 then
								--Raid Data
								
								
								varBossCount = thisPlayerTables[i]['profile']['currentRaid']['bossCount']
								varRaidName = thisPlayerTables[i]['profile']['currentRaid']['shortName']
								
								
								if (thisPlayerTables[i]['profile']['previousRaid']) then
									varBossCountPrevious = thisPlayerTables[i]['profile']['previousRaid']['bossCount']
									varRaidNamePrevious = thisPlayerTables[i]['profile']['previousRaid']['shortName']
								
								end
								
								
								
								
								
								strRaidProgress = ""
								strRaidProgressPrevious = ""
								strRaidMainProgress = ""
								strRaidMainProgressPrevious = ""
								
								for z=1,3  do
								
										-- current prog
										if (thisPlayerTables[i]['profile']['progress'][z]) then
										
										
											if (thisPlayerTables[i]['profile']['progress'][z]['difficulty']) == 1 then
												--Normal
												
												strRaidProgress = strRaidProgress .. normalRaidColor .. "    N " .. normalRaidColorText .. thisPlayerTables[i]['profile']['progress'][z]['progressCount'] .. "/" .. varBossCount
												
												
											end
											
											if (thisPlayerTables[i]['profile']['progress'][z]['difficulty']) == 2 then
												--Heroic
												 
												strRaidProgress = strRaidProgress .. heroicRaidColor .. "    H " .. heroicRaidColorText .. thisPlayerTables[i]['profile']['progress'][z]['progressCount'] .. "/" .. varBossCount
												
											end
											
											
											if (thisPlayerTables[i]['profile']['progress'][z]['difficulty']) == 3 then
												--Mythic												
												strRaidProgress = strRaidProgress .. mythicRaidColor .. "    M " .. mythicRaidColorText .. thisPlayerTables[i]['profile']['progress'][z]['progressCount'] .. "/" .. varBossCount
												
											end
											

										end
										
										
										--main's progress
										if (thisPlayerTables[i]['profile']['mainProgress']) then
										
											if (thisPlayerTables[i]['profile']['mainProgress'][z]) then
										
										
												if (thisPlayerTables[i]['profile']['mainProgress'][z]['difficulty']) == 1 then
													--Normal
													if (thisPlayerTables[i]['profile']['mainProgress'][z]['progressCount'] >= thisPlayerTables[i]['profile']['progress'][z]['progressCount']) then
														strRaidMainProgress = strRaidMainProgress .. normalRaidColor .. "    N " .. normalRaidColorText .. thisPlayerTables[i]['profile']['mainProgress'][z]['progressCount'] .. "/" .. varBossCount
													end
													
												end
												
												if (thisPlayerTables[i]['profile']['mainProgress'][z]['difficulty']) == 2 then
													--Heroic
													 
													if (thisPlayerTables[i]['profile']['mainProgress'][z]['progressCount'] >= thisPlayerTables[i]['profile']['progress'][z]['progressCount']) then
														strRaidMainProgress = strRaidMainProgress .. heroicRaidColor .. "    H " .. heroicRaidColorText .. thisPlayerTables[i]['profile']['mainProgress'][z]['progressCount'] .. "/" .. varBossCount
													end
												end
												
												
												if (thisPlayerTables[i]['profile']['mainProgress'][z]['difficulty']) == 3 then
													--Mythic
													if (thisPlayerTables[i]['profile']['mainProgress'][z]['progressCount'] >= thisPlayerTables[i]['profile']['progress'][z]['progressCount']) then													
														strRaidMainProgress = strRaidMainProgress .. mythicRaidColor .. "    M " .. mythicRaidColorText .. thisPlayerTables[i]['profile']['mainProgress'][z]['progressCount'] .. "/" .. varBossCount
													end
													
												end
												

											end
										
										end
										
										-- previous prog
										if (thisPlayerTables[i]['profile']['previousProgress']) then
											if (thisPlayerTables[i]['profile']['previousProgress'][z]) then
											
											
												if (thisPlayerTables[i]['profile']['previousProgress'][z]['difficulty']) == 1 then
													--Normal
													
													strRaidProgressPrevious = strRaidProgressPrevious  .. normalRaidColor .. "    N " .. normalRaidColorText .. thisPlayerTables[i]['profile']['previousProgress'][z]['progressCount'] .. "/" .. varBossCountPrevious
													
													
												end
												
												if (thisPlayerTables[i]['profile']['previousProgress'][z]['difficulty']) == 2 then
													--Heroic
													 
													strRaidProgressPrevious = strRaidProgressPrevious .. heroicRaidColor .. "    H " .. heroicRaidColorText .. thisPlayerTables[i]['profile']['previousProgress'][z]['progressCount'] .. "/" .. varBossCountPrevious
													
												end
												
												
												if (thisPlayerTables[i]['profile']['previousProgress'][z]['difficulty']) == 3 then
													--Mythic												
													strRaidProgressPrevious = strRaidProgressPrevious .. mythicRaidColor .. "    M " .. mythicRaidColorText .. thisPlayerTables[i]['profile']['previousProgress'][z]['progressCount'] .. "/" .. varBossCountPrevious
													
												end
												

											end
										end
										
										
										
										
								
								end
								
								
			
			
								if (strRaidProgress ~= "") then
								
									TRP3_CharacterTooltip:AddDoubleLine(varRaidName .. " Progress" , strRaidProgress, 0.8, 0.8, 0.8 );
								
									fixFontsTrp3RIO()
									
								
								end
								
								if (strRaidMainProgress ~= "") then
								
									TRP3_CharacterTooltip:AddDoubleLine("Main's " .. varRaidName .. " Progress" , strRaidMainProgress, 0.8, 0.8, 0.8 );
								
									fixFontsTrp3RIO()
									
								
								end
								
								
								
											
								
								
							
								
								if (strRaidProgressPrevious ~= "" and strRaidProgress == "") then
									-- only show previous progress if nothing in current progress, useful when there's only 1 raid in current tier
								
									TRP3_CharacterTooltip:AddDoubleLine(varRaidNamePrevious .. " Progress" , strRaidProgressPrevious, 0.8, 0.8, 0.8 );
									
									fixFontsTrp3RIO()
									
								
								end
								
								
								
								
								
								
							end
						
						
						end 
						
					
					
					end
				
					
					
						
					--for k, v in pairs(thisPlayerTables[2]['profile']['progress'][1]) do
					-- print(k, v)
					--end
					
					--for k, v in pairs(thisPlayerTables[2]['profile']['progress'][2]) do
					-- print(k, v)
					--end
					
					
					--for k, v in pairs(RaiderIO.GetScoreColor(thisPlayerTables[1]['profile']['mplusCurrent']['score'])) do
					 --print(k, v)
					--end
					
					--print(thisPlayerTables[1]['profile']['dataType'])
					
					
					
					
				end
				
					
				 
				TRP3_CharacterTooltip:Show()
				TRP3_CharacterTooltip:GetTop()
				
	
				
			
			end)
		end
	 
	 
	 
		    
    end
	
	
	
end)

